# include	"ListEdit.h"
# include	"FLMapInfo.h"

/*
 * Resource numbers
 */

typedef enum					/* alert/dialog numbers */
{
	aboutAlrtNum = 1000,	/* "About FaceLift..." alert */
	msgeAlrtNum,
	questAlrtNum,
	replaceAlrtNum
};


typedef enum
{
	fileMenuNum = 1000,
	editMenuNum,
	optionsMenuNum,
	tempMenuNum			/* used for yanking font names from system */
};


typedef enum			/* STR# resource numbers */
{
	fontStrNum = 1000	/* standard font list */
};


# define	helpTextNum		1000	/* TEXT for help window */


typedef enum		/* Undo operations */
{
	noUndo,			/* = "last op can't be undone" */
	undoDelete,
	undoInsert,
	undoPaste,
	undoReverse,
	undoFieldChg
};


typedef enum		/* field numbers - don't change */
{
	markField = 0,
	fontField,
	sizeField,
	styleField
};


# define	maxMappings	100


# define	faceCreator	'FACE'	/* creator of map files */
# define	faceType	'LIFT'	/* type of map files */
# define	mapVersion	1		/* version number of map files */


/*
 * Variable definitions
 */

extern WindowPtr	mapWind;

extern LListPtr	mapList;
extern MapSpec	mapSpec[];

extern Boolean	mapModified;
extern Boolean	showBadFormats;
extern Boolean	showCurFont;

extern int		undoOp;
extern int		undoVal;
extern int		undoPos;
extern int		undoFieldType;
extern MapSpec	undoSpec;



void ClearCSpec (ConvSpec *cSpec);
void ClearMSpec (MapSpec *mSpec);
short CompareCSpec (ConvSpec *c1, ConvSpec *c2);
void MSpecToMStr (MapSpec *mSpec, MapStr *mStr);
void MarkToStr (Boolean value, StringPtr str);
void FontToStr (int font, StringPtr str, StringPtr defStr);
void SizeToStr (int size, StringPtr str, StringPtr defStr);
void StyleToStr (int style, StringPtr str, StringPtr defStr);
void FormatToMSpec (Format *fmt, MapSpec *mSpec);

void ResourceFonts (Boolean);
void StrFonts (Boolean ask);

void ClearMapName (void);
void SetMapName (StringPtr name);
Boolean OpenMap (void);
Boolean AddMap (void);
Boolean SaveMap (Boolean askForName);
void Reformat (Boolean inPlace);
Boolean AddFormats (StringPtr bTitle, Boolean clobber);
void ShowFormats (void);

void GUnstruct3 (Globals3 *g);
void WUnstruct3 (Windows3 *w);
void GUnstruct6 (Globals6 *g);
void WUnstruct6 (Windows6 *w);
Boolean OpenMaca (StringPtr fName, int vRefNum);
void CloseMaca (void);
Boolean ReadPara (void);

Boolean SetFontSpec (int fNum, StringPtr fName);
void ResetFontList (void);
void SyncFontSpecs (void);
short FontIndex (int fontNum);
void FontName (int fontIndex, StringPtr str);
short SizeIndex (int size);
void SetMapFieldValue (int fieldType, int value);
void SetSelectors (int lineNo);
void MapSetup (void);

Boolean EqualMSpec (MapSpec *m1, MapSpec *m2);
Boolean StatMSpec (MapSpec *mSpec);
void SetMapFields (LineHandle hLine, MapStr *mStr);
void SelectMapping (int lineNo);
Boolean InsertMapping (MapSpec *mSpec, int n);
void NewMapping (void);
void DupMapping (int n);
void PasteMapping (MapSpec *mSpec, int n);
void DeleteMapping (int n);
void ClobberMap (void);
void SortMap (void);
void SquishMap (void);
void ReverseMap (void);

void FixMenus (void);
void SetupMenus (void);

void CopyString (StringPtr src, StringPtr dst);
void AppendString (StringPtr src, StringPtr dst);
short CompareString (StringPtr s1, StringPtr s2);
Boolean	MouseClick (void);
void DoEvents (int doTypes);
void DoUpdates (void);
void MakeFrontWind (WindowPtr w);
Boolean ExpandHandle (Handle h, Size delta);
Boolean DiscardChanges (void);
Boolean DestroyWarn (void);
void Message (StringPtr s1, StringPtr s2, StringPtr s3, StringPtr s4);
void Message1 (StringPtr s1);
void Message2 (StringPtr s1, StringPtr s2);
void Message3 (StringPtr s1, StringPtr s2, StringPtr s3);

void DisplayWindow (StringPtr title, Boolean visible);
void MeterPos (int h, int lineNo);
void MeterString (StringPtr s);
void MeterInt (int i);
void StartMeterParaInfo (int paras);
void SetMeterNum (int i);
void MeterErase (void);
void MeterBegin (void);
void MeterEnd (void);
void ErrWindInit (StringPtr fName);
void ErrWindMsge (StringPtr thing, int value);
void HelpWindow (void);
